//---------------------------------------------------------------------------

#include <vector.h>
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "sterowanie.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

struct Point3D
{
 float x;
 float y;
 float z;
};

struct Face
{
 vector<int,allocator<int> > VIndex;
};

float Scale;
int x0,y0,NumberOfFaces,NumberOfVerteces;
Point3D InitVertex[100];
Point3D Vertex[100];
Face Faces[20];
float M[4][4];

bool operator>(Face f1, Face f2)
{
 int i;
 float m1,m2;

 m1=-10000;
 for (i=0; i<f1.VIndex.size(); i++)
  if (Vertex[f1.VIndex[i]].z>m1) m1=Vertex[f1.VIndex[i]].z;
 m2=-10000;
 for (i=0; i<f2.VIndex.size(); i++)
  if (Vertex[f2.VIndex[i]].z>m2) m2=Vertex[f2.VIndex[i]].z;
 return (m2>m1); 
}

void SortFaces()
{
 int i,j;
 bool OK;
 Face Ftmp;
 do
 {
  OK=false;
  for (i=0; i<NumberOfFaces-1; i++)
   if (Faces[i]>Faces[i+1])
   {
    OK=true;
    Ftmp=Faces[i];
    Faces[i]=Faces[i+1];
    Faces[i+1]=Ftmp;
   }
 } while (OK);
}

void Transform(float &x, float &y, float &z, float xc, float yc, float zc)
{
 x=M[0][0]*xc+M[1][0]*yc+M[2][0]*zc+M[3][0];
 y=M[0][1]*xc+M[1][1]*yc+M[2][1]*zc+M[3][1];
 z=M[0][2]*xc+M[1][2]*yc+M[2][2]*zc+M[3][2];
}

void TransformVerteces()
{
 for (int i=0; i<NumberOfVerteces; i++)
  Transform(Vertex[i].x,Vertex[i].y,Vertex[i].z,InitVertex[i].x,InitVertex[i].y,InitVertex[i].z);
}

void Convert(float &x, float &y, float &z)
{
 float x1,y1,s=1;
 if (Form2->Perspektywa->Checked)
 {
  z+=Form2->Oddalenie->Position/10.0;
  x=x/z;
  y=y/z;
  s=Form2->Zoom->Position/10.0;
 }

 x1=x0+x*Scale*s;
 y1=y0-y*Scale*s;
 x=x1;
 y=y1;
}

bool IsVisible(Face *fc)
{
 Point3D u,v,w;
 u.x=Vertex[fc->VIndex[0]].x-Vertex[fc->VIndex[1]].x;
 u.y=Vertex[fc->VIndex[0]].y-Vertex[fc->VIndex[1]].y;
 u.z=Vertex[fc->VIndex[0]].z-Vertex[fc->VIndex[1]].z;
 v.x=Vertex[fc->VIndex[2]].x-Vertex[fc->VIndex[1]].x;
 v.y=Vertex[fc->VIndex[2]].y-Vertex[fc->VIndex[1]].y;
 v.z=Vertex[fc->VIndex[2]].z-Vertex[fc->VIndex[1]].z;
 w.z=u.x*v.y-u.y*v.x;
 if (w.z>0) return(false); else return(true);
}

void DrawFace(TCanvas *Canvas, Face *fc)
{
 int i;
 float x,y,z;
 TPoint v[10];
 for (i=0; i<fc->VIndex.size(); i++)
 {
  x=Vertex[fc->VIndex[i]].x;
  y=Vertex[fc->VIndex[i]].y;
  z=Vertex[fc->VIndex[i]].z;
  Convert(x,y,z);
  v[i].x=x;
  v[i].y=y;
 }
 if ((Form2->CheckBox1->Checked) && (Form2->RadioGroup2->ItemIndex==1))
 {
  Canvas->Brush->Style=bsSolid;
  Canvas->Brush->Color=clBtnFace;
 }
 else
  Canvas->Brush->Style=bsClear;
 Canvas->Polygon(v,fc->VIndex.size()-1);
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
 InitVertex[0].x=-1; InitVertex[0].y=-1; InitVertex[0].z=-1;
 InitVertex[1].x=-1; InitVertex[1].y=1;  InitVertex[1].z=-1;
 InitVertex[2].x=1;  InitVertex[2].y=-1; InitVertex[2].z=-1;
 InitVertex[3].x=1;  InitVertex[3].y=1;  InitVertex[3].z=-1;
 InitVertex[4].x=-1; InitVertex[4].y=-1; InitVertex[4].z=1;
 InitVertex[5].x=-1; InitVertex[5].y=1;  InitVertex[5].z=1;
 InitVertex[6].x=1;  InitVertex[6].y=-1; InitVertex[6].z=1;
 InitVertex[7].x=1;  InitVertex[7].y=1;  InitVertex[7].z=1;
 NumberOfVerteces=8;
 Faces[0].VIndex.insert(Faces[0].VIndex.end(),0);
 Faces[0].VIndex.insert(Faces[0].VIndex.end(),2);
 Faces[0].VIndex.insert(Faces[0].VIndex.end(),3);
 Faces[0].VIndex.insert(Faces[0].VIndex.end(),1);
 Faces[1].VIndex.insert(Faces[1].VIndex.end(),4);
 Faces[1].VIndex.insert(Faces[1].VIndex.end(),5);
 Faces[1].VIndex.insert(Faces[1].VIndex.end(),7);
 Faces[1].VIndex.insert(Faces[1].VIndex.end(),6);
 Faces[2].VIndex.insert(Faces[2].VIndex.end(),1);
 Faces[2].VIndex.insert(Faces[2].VIndex.end(),5);
 Faces[2].VIndex.insert(Faces[2].VIndex.end(),4);
 Faces[2].VIndex.insert(Faces[2].VIndex.end(),0);
 Faces[3].VIndex.insert(Faces[3].VIndex.end(),7);
 Faces[3].VIndex.insert(Faces[3].VIndex.end(),3);
 Faces[3].VIndex.insert(Faces[3].VIndex.end(),2);
 Faces[3].VIndex.insert(Faces[3].VIndex.end(),6);
 Faces[4].VIndex.insert(Faces[4].VIndex.end(),0);
 Faces[4].VIndex.insert(Faces[4].VIndex.end(),4);
 Faces[4].VIndex.insert(Faces[4].VIndex.end(),6);
 Faces[4].VIndex.insert(Faces[4].VIndex.end(),2);
 Faces[5].VIndex.insert(Faces[5].VIndex.end(),7);
 Faces[5].VIndex.insert(Faces[5].VIndex.end(),5);
 Faces[5].VIndex.insert(Faces[5].VIndex.end(),1);
 Faces[5].VIndex.insert(Faces[5].VIndex.end(),3);
 NumberOfFaces=6;
 for (int i=0; i<4; i++)
  for (int j=0; j<4; j++)
   M[i][j]=0;
 M[0][0]=1; M[1][1]=1; M[2][2]=1; M[3][3]=1;
 TransformVerteces();
} 
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
 int i;
 if ((Form2->CheckBox1->Checked) && (Form2->RadioGroup2->ItemIndex==1))
  SortFaces();
 for (i=0; i<NumberOfFaces; i++)
  if (Form2->CheckBox1->Checked)
  {
   if (IsVisible(&Faces[i])) DrawFace(Canvas,&Faces[i]);
  }
  else DrawFace(Canvas,&Faces[i]);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
 float Sx,Sy;
 x0=ClientWidth/2;
 y0=ClientHeight/2;
 Sx=ClientWidth/4;
 Sy=ClientHeight/4;
 if (Sx<Sy) Scale=Sx; else Scale=Sy;
 Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
 Form2->Show();        
}
//---------------------------------------------------------------------------

